var sfns = ["number","⍸","∊","⍳"],
    labels = ["1", "2", "4"],
    lens = [
        ["size"],
        [  ""," ", "1"],
        [ "2","-", "3"],
        [ "4","-", "7"],
        [ "8","-","15"],
        ["16","-","31"],
        ["32","-","63"],
        [  "", "",""  ],
        [  "","-", "…"],
    ],
    times_ = [
        [ 43,   90,  240],  [ 36,   51,  132],  [ 37,   51,  131],
        [ 70,  175,  348],  [ 94,  205,  350],  [132,  258,  491],
        [ 98,  243,  522],  [133,  295,  558],  [168,  344,  815],
        [138,  368,  976],  [181,  418, 1026],  [232,  514, 1305],
        [187,  570,    0],  [230,  617,    0],  [319,  799,    0],
        [281,    0,    0],  [342,    0,    0],  [494,    0,    0],
        [  0,    0,    0],  [  0,    0,    0],  [  0,    0,    0],
        [181,  695,    0],  [110,  573,  759],  [588,  520, 7300]
    ],
    times = [[],[],[]];
times_.forEach((t,i) => times[i%3].push(t));

var tab = d3.select("table").style("font-size","38px").style("margin-top","-14px");

tab.append("tr")
    .selectAll().data(sfns).enter().append("th").text(p=>p)
    .filter(t=>t==="number").style("font-weight","normal").style("position","absolute");
var tabs = tab.append("tr");
var lent = tabs.append("td").append("table")
    .selectAll().data(lens).enter().append("tr").style("text-align","right")
    .selectAll().data(t=>t).enter().append("td").style("width","auto")
    .text(t=>t);
lent.filter((_,i)=>i==1).style("text-align","center");
lent.filter(t=>t==="size").attr("colspan",3).style("text-align","center").style("font-weight","bold");
var stab = tabs.selectAll().data(times).enter().append("td").append("table").style("margin-left","14px").style("margin-right","16px");
stab.append("tr").style("text-align","center")
    .selectAll().data(t=>labels).enter().append("th")
    .text(l=>l);
stab.selectAll().data(t=>t ).enter().append("tr").style("text-align","right")
    .selectAll().data(t=>t ).enter().append("td")
    .filter(t=>t).style("background", t=>d3.interpolateWarm(2-Math.log(t)/5))
    .selectAll().data(t=>{var d=""+t; return Array.from(d).map((c,i)=>[c,0.2+i-d.length+Math.log10(t)])}).enter().append("span")
    .text(t=>t[0])
    .filter(t=>t[1]>0)
    .style("color",t=>"rgba(34,34,34,0.6)")
    .style("text-shadow",t=>"0 0 "+(2.4*t[1])+"px rgba(34,34,34,"+(1-Math.pow(t[1],1.3)/20)+")");
