var targ = [];
for (var i=0; i<16; i++) targ[i] = {d:i, h:"0001"};
targ[16] = {d:-1, h:""};

var defs= d3.select("#svg").append("defs"),
    svg = d3.select("#svg").append("g").attr("transform", "scale(2)");

var h0 = 30;
var x = i=>36+48*i;

var j = []; for (var ji=0; ji<68; ji++) j[ji]=ji;

svg.append("rect").attrs({x:36, y:h0-1, width:17*48, height:18, stroke:"black", "stroke-width":1, fill:"none"});

svg.append("rect").attrs({x:x(0)+1, y:h0, width: 4*48-2, height:16, fill:"#7a9"});
svg.append("rect").attrs({x:x(4)+1, y:h0, width:13*48-2, height:16, fill:"#d9a"});

var boxes = svg.selectAll().data(j).enter();
boxes.append("text").attrs({x:i=>36+6+12*i, y:h0-4, "font-size":7, "text-anchor":"middle"}).text(i=>i);
boxes.filter(i=>i!=0&&i!=16)
    .append("line").attrs({x1:i=>36+12*i, x2:i=>36+12*i, y1:h0, y2:h0+16, stroke:"black", "stroke-width":0.5, opacity:0.3});

function halfBrace(x1,x0,y1,y0,e)
{
    var yh = (y0 + y1)/2,
        d  = x1>x0 ? 10 : -10;

    return "M"+x0+" "+y0 + "Q"+x0+" "+yh+" "+(x0+d)+" "+yh
    + (e ? "L"+(x1-d)+" "+yh + "Q"+x1+" "+yh+" "+x1+" "+y1 : "")
         ;
}

function fullBrace(x1,x2,y1,w,e)
{
    var xh = (x1+x2)/2;
    return halfBrace(x1,xh,y1,y1+w,1) + halfBrace(x2,xh,y1,y1+w,e);
}

var lcolor = ["#324b36","#693238"],
    tcolor = ["#021","#801"];

var h1 = h0+20,
    hh = h1+5;
svg.selectAll().data([
        fullBrace(x(0)+2,x( 4)-2,h1,12,1)
      , fullBrace(x(4)+2,x(10)-2,h1,12,0)+"L"+x(17)+" "+hh
      , "M"+x(4.96)+" "+(h1+57) + "A2e4 2e4 0 0 0"+(x(17))+" "+(h1+47)
      , "M"+x(0.2 )+" "+(h1+45) + "A400 400 0 0 1"+(x(0)+6)+" "+h1
    ]).enter().append("path")
    .attrs({d:d=>d, fill: "none", "stroke-width":2,
            stroke:(_,i)=>lcolor[i%2], opacity:(_,i)=>i<2?1:0.5});

svg.selectAll().data([[2,-1], [7,0]]).enter()
    .append("text")
    .attrs({x:d=>x(d[0]), y:h0+50, "text-anchor":"middle", "font-size":16, fill:(_,i)=>tcolor[i]})
    .text(d=>"h⁻¹("+d[1]+")");

svg.selectAll().data([[4.2,-1,"#021"], [0.5,0,"#801"]]).enter()
    .append("text")
    .attrs({x:d=>x(d[0]), y:h1+62, "text-anchor":"middle", "font-size":17, fill:(_,i)=>tcolor[i], opacity:0.8})
    .text(d=>"h(k)="+d[1]);

defs.append("linearGradient").attr("id", "edge")
    .selectAll().data([0,1]).enter().append("stop")
    .attrs((e,i)=>({"stop-color": "white", offset:i*0.8, "stop-opacity":e}));

svg.append("rect")
    .attrs({x:x(13), y:0, width:x(17)-x(13), height:120, "fill":(_,i)=>"url(#edge)"});
