// var height = 724,
//     width  = 1320;

var msk =      90,  xk = msk-22,
    ind = msk+162,
    i0  = ind+185,  ik = i0-66,  crc= i0+72,
    i1  = i0 +223,  it = i1-56,  ir = (i1+i0)/2,
    i2  = i1 +142,  ii = i2-40,
    val = i2 +145,
    out = val+173,  i3 = out-60;

var j0 =     20,
    s  =     80,  jm = s +50,
    j1 = s +180,  ja = j1+70,  ji = j1-50,  jk = j1-70,
    j2 = j1+120,  jb = ja+90,  js = j2-20,  yk = j2+60,
    j3 = j2+ 84,  jt = j3-70,
    j4 = j3+ 76,
    j5 = j4+ 80,
    f  = j5+ 96;

var reg   = "black",
    vec   = "#a8233b", vecbg = "#f6e8eb",
    load  = "#406ac2", loadt = "#2455bd",
    cnst  = "#b2b2b2", cnstt = "#999",
    opc   = "#555",    opct  = "#444";

var svg = d3.select("#svg");

svg.append("rect")
    .attrs({x:ir, y:40, width:out+100-ir, height:f-j0-40, fill:vecbg});

var lines = svg.selectAll().data([
        {x1:ik, x2:ik,  y1:j0, y2:f , stroke:load, opacity:0.3},
        {x1:it, x2:it,  y1:j0, y2:f , stroke:load, opacity:0.3},

        {x1:msk, x2:msk,  y1:j0, y2:f },
        {x1:msk, x2:i0 ,  y1:j2, y2:j2},
        {x1:ind, x2:ind,  y1:j0, y2:f },
        {x1:ind, x2:i0 ,  y1:j1, y2:j1},
        {x1:crc, x2:crc,  y1:j0, y2:f , stroke:cnst},
        {x1:i0 , x2:crc-2,y1:jm, y2:jm, stroke:cnst},
        {x1:i0 , x2:i0 ,  y1:jm, y2:j3},
        {x1:i0 , x2:i1 ,  y1:j3, y2:j3},
        {x1:i1 , x2:i1 ,  y1:j3, y2:j4, stroke:vec},
        {x1:i2 , x2:i2 ,  y1:js, y2:j4, stroke:vec},
        {x1:val, x2:val,  y1:j0, y2:f , stroke:vec},
        {x1:i2 , x2:val,  y1:js, y2:js, stroke:vec},
        {x1:i1 , x2:i2 ,  y1:j4, y2:j4, stroke:vec},
        {x1:i2 , x2:i2 ,  y1:j4, y2:j5, stroke:vec},
        {x1:out, x2:out,  y1:j0, y2:f , stroke:vec},
        {x1:i3 , x2:out,  y1:ja, y2:ja, stroke:vec},
        {x1:i2 , x2:out,  y1:j5, y2:j5, stroke:vec},
        {x1:i3 , x2:i3 ,  y1:ja, y2:jb, stroke:vec},
        {x1:i3 , x2:out,  y1:jb, y2:jb, stroke:vec},

        {x1:ii , x2:i0 ,  y1:ji, y2:j1, stroke:opc, "stroke-dasharray":"8,10"},
        {x1:ii , x2:i2 ,  y1:ji, y2:js, stroke:opc, "stroke-dasharray":"8,10"},

        {x1:ik , x2:ik+8,  y1:jk, y2:j1, stroke:load, "stroke-dasharray":"7,10"},
        {x1:it , x2:it+8,  y1:jt, y2:j3, stroke:load, "stroke-dasharray":"7,10"}
    ]).enter().append("g");
lines.filter(l=>l.x2==ind||l.y1==j5)
    .append("line")
    .attr("stroke", l=>l.x2==ind?"white":vecbg)
    .attr("stroke-width", 15)
    .attrs(l => {var dx=4,dy=4; if(l.x1===l.x2)dx=0;else dy=0; return {x1:l.x1+dx,x2:l.x2-dx,y1:l.y1+dy,y2:l.y2-dy};})
lines.append("line")
    .attr("stroke", reg)
    .attr("stroke-width", 5)
    .attr("stroke-linecap", "round")
    .attrs(l=>l);

function getbox(d) {
    var w=d.w, h=d.h,
        a = {x:d.x-w/2, y:d.y-h/2, width:w, height:h};
    if (d.noborder)
        a.fill = a.x<ir ? "white" : vecbg;
    else
    {
        a["stroke-width"] = 2;
        a.stroke = "black";
        a.fill = d.load ? "#dce4f5" : "#eee";
    }
    return a;
}

var boxes = svg.selectAll().data([
        {text:"mask"     , x:msk, y:s , h:42, w:210, "font-size":36, noborder:1},
        {text:"index"    , x:ind, y:s , h:42, w:120, "font-size":36, noborder:1},
        {text:"targets"  , x:val, y:s , h:42, w:140, "font-size":36, noborder:1},
        {text:"output"   , x:out, y:s , h:42, w:140, "font-size":36, noborder:1},
        {text:"crc"      , x:crc,y:s-28,h:28, w: 20, "font-size":28, fill:cnstt, noborder:1},
        {text:"code"     , x:crc,y:s   ,h:28, w: 20, "font-size":28, fill:cnstt, noborder:1},
        {text:"mov"      , x:i0 , y:jm, h:42, w: 78},
        {text:"targets"  , x:ik , y:jk, h:42, w:114, load:1, fill:loadt, noborder:1},
        {text:"crc32"    , x:i0 , y:j1, h:42, w:114, load:1},
        {text:"∧"        , x:i0 , y:j2, h:50, w: 70, "font-size":50},
        {text:"table"    , x:it , y:jt, h:42, w: 94, load:1, fill:loadt, noborder:1},
        {text:"load"     , x:i1 , y:j3, h:42, w: 94, load:1},
        {text:"UNROLLED" , x:ii,y:ji-16,h:40, w:170, "font-size":30, fill:opct, noborder:1},
        {text:"INDEX"    , x:ii,y:ji+16,h:36, w:170, "font-size":30, fill:opct, noborder:1},
        {text:"select"   , x:i2 , y:js, h:42, w:136},
        {text:"="        , x:i2 , y:j4, h:50, w: 70, "font-size":50},
        {text:"+"        , x:out, y:jb, h:50, w: 70, "font-size":50},
        {text:"-"        , x:out, y:j5, h:50, w: 70, "font-size":68}
    ]).enter();
boxes.append("rect")
    .attrs(getbox);
boxes.append("text")
    .attr("text-anchor", "middle")
    .attrs(d=>{
        var fs=d["font-size"]||34,
            a = {x:d.x, y:d.y+fs/3-3*(d.text==="-"), fill:d.fill, "font-size":fs};
        if (!d.noborder) a["font-family"] = "monospace";
        return a;
    })
    .text(d=>d.text);

svg.append("rect")
    .attrs({x:xk-36, y:yk-21, width:288, height:286, fill:"#f6f8ff",
            opacity:0.96,
            "stroke-width":2, stroke:"#e3e6f0"});
var legend = svg.selectAll().data([
        {text:"instruction", x:xk-22, y:yk    ,              fill:"#111"  , w:240},
        {text:"register"   , x:xk   , y:yk+ 54, stroke:reg , fill:"#161616", noborder:1},
        {text:"pointer"    , x:xk+22, y:yk+ 90, stroke:load, fill:loadt, noborder:1, opacity:0.5},
        {text:"constant"   , x:xk+22, y:yk+126, stroke:cnst, fill:cnstt, noborder:1},
        {text:"vector reg" , x:xk   , y:yk+174, stroke:vec , fill:vec  , noborder:1},
        {text:"opcode"     , x:xk   , y:yk+222, stroke:opc , fill:opct , noborder:1, "stroke-dasharray":"4,8"},
    ]).enter();
legend.filter(d=>d.noborder!==1).append("rect")
    .attrs(d=>({x:d.x+9, y:d.y-7, width:d.w, height:42,
                "stroke-width":2, stroke:"#333", fill:"#eee"}));
legend.filter(d=>d.stroke)
    .append("line")
    .attrs(d=>({x1:xk, x2:xk, y1:d.y, y2:d.y+30,
                "stroke-width":5, "stroke-linecap":"round", opacity:d.opacity,
                stroke:d.stroke, "stroke-dasharray":d["stroke-dasharray"]}));
legend.append("text")
    .attrs(d=>{
        var fs=34,
            a = {x:d.x+16, y:d.y+25, fill:d.fill, "font-size":fs};
        if (!d.noborder) a["font-family"] = "monospace";
        return a;
    })
    .text(d=>d.text);
svg.append("rect")
    .attrs({x:xk-35, y:yk-20, width:290, height:288, fill:"white",
            opacity:0.16});


var critpath = svg.append("path")
    .attrs({fill:"none", stroke:"yellow", "stroke-width":3, "stroke-linecap":"round"})
    .attr("d", "M"+crc+" "+(j0-3)+"V"+jm+"H"+i0+"V"+j3+"H"+i1+"V"+j4+"H"+i2+"V"+j5+"H"+out+"V"+(f+3))
    .attr("opacity", 0);

document.onclick = function() {
    critpath.transition().duration(500).attr("opacity", 1);
}
